<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2//EN">

<HTML>

<HEAD>
<TITLE>Cours/TD - 8</TITLE>
<link REL="StyleSheet" TYPE="text/css" HREF="Costyle.css">

</HEAD>
<BODY BACKGROUND="../icons/bk_rose.jpeg">

<p>
<H1>Cours/TD - (8)</H1>
<P>
<p>


<TABLE width=100%>
 <TR><TD align=left><A HREF="comres7.html"><IMG SRC="../icons/gb_larr.gif" border=0 align=absmiddle></A></TD>
<TD align=right><A HREF="comres9.html"><IMG SRC="../icons/gb_rarr.gif" border=0 align=absmiddle></A></TD>
</TR>
</TABLE>
<p>
<FONT COLOR=#0000FF FACE="Helvetica,Arial" point-size=14pt>

<H3><FONT COLOR=#f00000>30.11.99</FONT></H3>
<p>


<H2>Cours/TD</H2>
<SPAN class=ib>(Version définitive. Il n'y aura plus de versions préliminaires, car ceci visiblent ne sert à rien. Tant pis.)</SPAN>
<p>

<EM>Aujourd'hui les TD étaient consacrés à la discussion des notions introduites en cours, et aux exemples. J'ai placé la totalité dans un texte contigu, sans séparer les deux parties.</EM>
<p>

<H3>Parseurs monadiques, récapitulation</H3>

Nous avons précédemment défini l'objet monadique de type "parseur universel", et deux procédures génériques qui ne font rien avec le flot d'entrée ; une échoue, et l'autre retourne son paramètre apparié avec le flot original, dans le seul élément de la réponse :
<PRE class="rp">
type UParser c a = [c] -&gt; [(a,[c])]

return x = \inp -&gt [(x,inp)]
fail = \inp -&gt; []
</PRE>
En général un tel parseur (non-déterministe) est une fonction qui prend un flot de données d'entrée : une liste d'objets de type <TT>c</TT>, et retourne la liste de réponses, où chaque item est de type <TT>a</TT>. <br>
<p>

<EM>Nous allons changer notre protocole et nos définitions</EM> - légèrement, mais de manière importante. La couleur rouge des définitions ci-dessus signifie leur abandon.
<p>

Nous voulons qu'un parseur se comporte plutôt comme un "objet" que comme une fonction. On n'appliquera pas directement (p. ex. <TT>parseur liste</TT>, mais à travers un "opérateur de parsing" <TT>(-*&gt;)</TT>, p. ex. <TT>parseur -*&gt; liste</TT>. On définira cet objet - parseur comme
<PRE>
newtype UParser c a = Pa ([c] -&gt; [(a,[c])])
</PRE>
une structure balisée par le constructeur <TT>Pa ... </TT>, dont le contenu est la fonction de parsing précédente - une fonction qui agit sur le flot d'entrée, et renvoie la collection de paires (<I>résultat,flot_restant</I>). L'opérateur <TT>(-*&gt;)</TT> est défini comme suit :
<PRE>
infix  1 -*&gt;

Pa p -*&gt; inp = p inp
</PRE>
ce qui est assez trivial, on en extrait la fonction de parsing, et on l'applique.
<p>

Le mot-clé <TT>newtype</TT> en Haskell est une nouveauté pour vous. Ceci est presque équivalent à <TT>data</TT>, à la définition d'un nouveau type structuré, et identifié par une balise-constructeur dans le programme-source. Mais dans le code compilé cette balise disparaît sans laisser aucune trace, et la représentation interne d'un parseur <SPAN class=ib>est</SPAN> une fonction. La construction <TT>newtype</TT> sert à definir des nouveaux types, considérés différents de tous les types existants, même si son implantation, sa représentation interne est la même que pour un autre type. Ainsi nous aurions pu définir la pile des retours <TT>Rstack</TT> de notre machine virtuelle à pile, à travers l'opérateur <TT>(:&gt;)</TT>, mais en même temps permettre à la machine d'utiliser les listes standard, qui peuvent être gérées de manière un peu plus efficace que les structures définies par l'utilisateur. 
<p>
(Un autre exemple peut-être... Imaginez un programme qui traite un problème numérique très complexe, avec les nombres qui décrivent le temps, les coordonnées spatiales, l'intensité d'un champ, la temperature, et autres choses de manière si intriquée, que l'on risque de mélanger des objets appartenant aux familles différentes. Beaucoup d'erreurs peut être évité si on donne des types différentes au temps, à la température, etc. Mais tout ceci n'est qu'un nombre réel ! Alors pour avoir le beurre et l'argent du beurre, on introduit le pseudo-balisage par newtype. Le programme est un peu plus long à écrire, car il faut remplacer, disons, 2.3 par (T 2.3) ou (Dgr 2.3), et surcharger quelques opérations arithmétiques, mais on gagne en lisibilité, ce qui facilite le déboguage et on ne perd rien en vitesse d'exécution.)
<p>



Ici l'usage d'un parseur devient légèrement plus complexe, on ne peut pas l'appliquer comme une fonction à un flot de données, il faut destructurer la forme <TT>Pa ...</TT> et en extraire la fonction cachée. Mais la présence de l'opérateur <TT>-*&gt;</TT> facilite la lecture des programmes plus longs. Le choix de sa forme est totalement arbitraire, et si elle ne vous plaît pas, nous pouvons la changer immédiatement. La priorité de cet opérateur est très faible, pour éviter trop de parenthèses à droite. Il n'est pas associatif
<p>

Voici maintenant la vraie définition des opérateurs <TT>return</TT>, etc.:
<PRE>
instance Monad (UParser c) where
  fail s = Pa (\_ -&gt; [])
  return x = Pa (\inp -&gt; [(x,inp)])
  Pa p &gt;&gt;= f = 
    Pa (\inp -&gt; concat[(f v)-*&gt;out|(v,out)&lt;-p inp])
</PRE>
Le <TT>return</TT> est le même, on a ajouté la balise <TT>Pa</TT>. L'échec <TT>fail</TT> prend un paramètre, ceci doit être une chaîne de caractères qui contient le message destiné au programmeur. La définition par défaut du <TT>fail</TT> dans la classe <TT>Monad</TT> est : <TT>error</TT>. Dans notre cas nous échouons silencieusement en retournant la liste vide, et le paramètre <TT>s</TT> est ignoré (il a pu être anonyme).
<p>

<EM>Notez bien !</EM> Les  fonctions <TT>return, fail</TT> et l'opérateur <TT>(&gt;&gt;=)</TT> sont surchargées, ces opérations existent pour tous les types admissibles par la classe <TT>Monad</TT>, il faut les définir donc dans l'instance de cette classe. L'opérateur <I>bind</I> est assez simple : on décortique la fonction du parseur, on l'applique au flot d'entrée, ce qui donne une liste de réponses. La fonction <TT>f</TT> s'applique à chacune des réponses dans (l'itération effectuée par <TT>map</TT>), et le résultat est un parseur qui doit s'appliquer au flot restant. <SPAN class=ib>On ne peut pas se tromper ici</SPAN>. Je vous rappelle que la compréhension <TT>[f x | x&lt;l]</TT> est un synonyme de <TT>map f l</TT>. Mais la fonction <TT>f</TT> par définition doit retourner un objet monadique, une liste non-déterministe, donc il faut appliquer encore <TT>concat</TT>, pour se débarasser des listes de listes.
<p>

<EM>Encore un détail important !</EM> Nous avons dit qu'une monade est <SPAN class=ib>un constructeur de données</SPAN>. Si on définit le type <TT>data Maybe a = Nothing | Just a</TT>, l'instance en question serait
<pre>
instance Monad Maybe where
 return x = Just x
 fail s = Nothing
 Just x  &gt;&gt;= k = k x
 Nothing &gt;&gt;= k = Nothing
</pre>
<SPAN class=ib>Il faut apprivoiser cette technique de surcharge</SPAN>, elle ressemble un peu à la définition de méthodes surchargées dans des classes différentes. En Haskell on ne peut dire qu'un objet, qu'une donnée appartienne à une classe. Par contre, <SPAN class=ib>son type</SPAN> peut appartenir à une classe. <EM>Les classes et les types sont des catégories très différentes</EM>. La classe précise qu'un certain nombre de "méthodes" (fonctions surchargées) existe, et dans l'<TT>instance</TT> on précise leur implantation. Les fonctions <TT>return</TT> pour le type <TT>UParser c</TT> et pour <TT>Maybe</TT> sont très différentes.
<p>

Il existe aussi un moyen de définir quelques méthodes par défaut. Par exemple dans la définition suivante (copiée depuis le Prélude standard) qui déclare la classe <TT>Monad</TT> (pour un type quelconque symbolisé par le nom <TT>m</TT>)
<a name="clamon"> </a>
<PRE>
class Monad m where
  return :: a -&gt; m a
  (&gt;&gt;=)  :: m a -&gt; (a -&gt; m b) -&gt; m b
  (&gt;&gt;)   :: m a -&gt; m b -&gt; m b
  fail   :: String -&gt; m a

  -- Définitions par défaut
  p &gt;&gt; q  = p &gt;&gt;= \ _ -&gt; q
  fail s  = error s
</PRE>
on spécifie <I>quelles sont</I> les méthodes (leur existence et leur types, sans les définir) de ce type de constructeur <TT>m</TT>. Vous pouvez à présent construire votre type monadique, et "oublier" de définir <TT>fail</TT>. Son usage déclenche la fonction <TT>error</TT>. <SPAN class=lb>(L'opérateur <TT>(&gt;&gt;)</TT> sera utilisé un peu plus tard, en TD)</SPAN>.
<p>


Ici, <TT>UParser</TT> possède deux paramètres, et "l'application partielle" <TT>UParser c</TT> est un constructeur parametré par le type <TT>a</TT>. Les classes multi-paramétriques en Haskell restent toujours mal comprises et leur usage est difficile. mais si nous voulons vraiment que nos parseurs soient universels, qu'ils puissent agir sur toute sorte de flots d'entrée et retourner des structures très diverses, ceci est utile.
<p>

Pour comprendre mieux le sens du <i>bind</i> dans le domaine des parseurs, il faut proposer quelques exemples d'analyseurs concrets (mais relativement primitifs et génériques). Par exemple, définissons un objet monadique qui coupe le premier item (par exemple le premier caractère) d'un flot, et le retourne tel quel :
<PRE>
type Cutter a = UParser a a

item :: Cutter a    -- déclarations de type redondantes
item = Pa (\inp -&gt; case inp of
            [] -&gt; []
            (x:xq) -&gt; [(x,xq)])
</PRE>
Si on définit :
<PRE>
dat = "Belle marquise, vos 123 yeux ..."
</PRE>
l'appel <TT>item -*&gt; dat</TT> retourne <TT>[('B',"elle marquise, vos 123 yeux ...")] :: [(Char,[Char])]</TT>.
<p>

Voici la définition primitive d'un autre parseur, <TT>sat p</TT> qui effectue le filtrage logique, vérifie si l'item suivant sur le flot d'entrée satisfait la condition Booléenne <TT>p</TT> :
<PRE>
sat p = Pa (sat' p) where
  sat' p [] = []
  sat' p (x:q) | p x = [(x,q)]
               | otherwise = []
</PRE>
Ce parseur peut être <SPAN class=ib>et sera</SPAN>utilisé pour filtrer les constantes. 
<p>

Si la règle syntaxique prévoit que le parseur trouve un objet concret <TT>c</TT> sur le flot d'entrée, par exemple une parenthèse ouvrante, on construit l'équivalent d'une constante dans la règle syntaxique par
<PRE>
literal c = sat (==c)   -- ou : sat (\x-&gt;x==c)
</PRE>
Maintenant <TT>literal 'B' -*&gt; dat</TT> retourne la même chose que l'<TT>item</TT> précédent, mais tout autre appel, par exemple <TT>literal 'x' -*&gt; dat</TT> échoue.
<p>

On peut le construire un peu différemment, à l'aide de l'enchaînement monadique :
<PRE>
sat p = item &gt;&gt;= \x -&gt; if p x then return x else fail []
</PRE>
La définition de l'opérateur <i>bind</i> combine l'extraction des éléments d'une suite non-déterministe par <TT>map/concat</TT> et la "fonctionnalisation" qui caractérise les transformateurs d'état.
<p>

Il <SPAN class=ib>faut s'habituer</SPAN> à de telles constructions, mais ceci nous offre la possibilité d'assembler les parseurs en toute indépendance du flot d'entrée ! Son existence est cachée, et le parseur s'approche dans sa forme à une production syntaxique "pure", où - bien sûr - il n'y a aucune source de données précisée explicitement. <SPAN class=lb>(D'ailleurs, une philosophie analogique facilite la construction des parseurs en Prolog ; essayez de lire quelque chose sur les grammaires DCG, ou attendez que ceci soit présenté en cours - et ne craignez rien : le mot "monades" n'y sera probablement jamais mentionné.)</SPAN>.
<p>

<H3>Combinateurs monadiques de parseurs</H3>

Le nombre de parseurs primitifs est très limité, il n'y a presque rien à ajouter, sauf - peut-être - la négation (le filtrage inverse). Toute la puissance des règles grammaticales réside dans les combinaisons : séquences et alternatives. Voici la définition du combinateur <TT><A HREF="javascript:alert('(le mot seq correspond à une primitive \nprédéfinie en Hugs')">seqp</A></TT>qui construit la séquence (concaténatation) de deux parseurs. Avant de présenter le code il faut répondre à la question : <SPAN class=ib>que fait-on avec les deux résultats?</SPAN>
Ceci dépend des détails "synthétiques" du parseur, de la façon de ramasser les items et de construire un noeud de l'arbre syntaxique. Nous verrons plus tard des exemples concrets, il est évident que la réponse est très différente dans ces cas, déjà vus :
<PRE class="he">
expr ::= terme expr | ...
expr ::= terme termlist

mot ::= lettre mot | ...
</PRE>
même si la juxtaposition style <B>N ::= A B | ...</B> reste identique. Donc, en attendant des exemples plus concrets, nous mettons les deux éléments de la séquence dans une paire <TT>(,)</TT> :
<PRE class=rp>
seqp p q = p &gt;&gt;= \x -&gt; q &gt;&gt;= \y -&gt; return (x,y)
</PRE>
mais pourquoi pas <TT>(x:y)</TT>? En fait, cet exemple suggère que le parseur <TT>seqp</TT> peut être paramétré par une procédure sémantique, souvent un <SPAN class=ib>constructeur</SPAN>, p. ex. 
<pre>
seqp cnstr p q = p&gt;&gt;= \x -&gt; q &gt;&gt;= \y -&gt; return (cnstr x y)
</pre>
Et ceci est la forme qui sera utilisée.
<p>

Passons à l'<EM>alternative</EM>. Nous avons deux possibilités de gérér cela, soit comme l'alternative non-exclusive, non-déterministe, soit comme le choix exclusif. Si le langage ne présente pas des ambiguïtés, normalement il est souhaitable d'éliminer le non-déterminisme d'un parseur, et nous en discuterons les détails plus tard. La forme la plus simple de l'alternative non-déterministe inclusive se réduit à
<PRE>
alt (Pa p) (Pa q) = Pa (\inp -&gt; p inp ++ q inp)
</PRE>
On concatène les réponses fournies par les deux membres alternatifs.
<p>

Voici la construction d'un parseur qui reconnaît les caractères alphanumériques. Elle est volontairement un peu longue, pour exposer les détails, on pourrait raccourcir la définition en introduisant les conditions logiques plus complexes. Commençons par le parseur qui vérifie si un caractère appartient à un intervalle (de codes numériques). On peut utiliser les relations d'ordre entre les caractères.
<PRE>
interv a b = sat (\c -&gt; a &lt= c && c &lt;= b)
digit = interv '0' '9'
lowcase = interv 'a' 'z'
upcase = interv 'A' 'Z'

letter = lowcase `alt` upcase
alphanum = letter `alt` digit
</PRE>
La simplicité cache une certaine inefficacité. Il est évident qu'une lettre n'est pas un chiffre, donc la "concaténation des solutions alternatives" se réduit toujours à un seul terme, un caractère ne peut être en même temps les deux. La même chose : une lettre n'est jamais minuscule ou majuscule en même temps. D'autre part on ne doit pas permettre qu'un parseur des nombres entiers transforme le flot "123;" en <TT>[("1","23;"), ("12","3;"), ("123",";")]</TT>, évidemment nous sommes intéressés par la solution la plus longue. La construction d'un tel parseur peut assurer que la solution la plus longue vienne d'abord, et nous pouvons toujours récupérer seulement le premier élément de la liste. Si le langage d'implantation est paresseux, les autres ne seront même pas générés (mais leur suspension peut consommer les ressources aussi). Pour un langage strict une alternative <SPAN class=ib>exclusive</SPAN> primitive s'impose. Par exemple
<PRE>
xor (Pa p) (Pa q) = 
  Pa (\inp -&gt; let s=p inp 
              in if s==[] then q inp else s)
</PRE>
On applique le premier parseur, et si (et seulement si) ce parseur échoue, et rend la liste vide, on applique le second parseur, sinon on garde le premier résultat. L'alternative exclusive est utilisée si souvent, que nous proposons une abréviation opérationnelle de basse précédence, ce qui évite trop de parenthèses :
<PRE>
infixl 0 #
a # b = xor a b
</PRE>
On peut remplacer <TT>alt</TT> par <TT>(#)</TT> dans les définitions de <TT>alphanum</TT>, etc.


<H3>Itérations</H3>

Essayons de définir un parseur qui assemble un mot - une suite de lettres, jusqu'à sa terminaison, l'occurrence d'un caractère qui n'est plus une lettre. On peut essayer d'implanter la règle
<PRE class="he">
word ::= lettre word'
word' ::= EPS | lettre word'
</PRE>
Nous avons déjà construit des parseurs épouvantables, de deux ou même quatre lignes !, donc il faut retourner à la simplicité. Voici la définition :
<PRE>
word = seqp (:) letter word'
word' = seqp (:) letter word' # return []
</PRE>
où <TT>seqp</TT> est - comme il a été suggéré - paramétré par l'opérateur "cons" <TT>(:)</TT>, qui assemble les lettres dans un mot-liste de caractères. L'expression <TT>word -*&gt; dat</TT> récupère le mot "Belle". La construction des listes est une opération assez fréquente. Un fonctionnaliste maniacal aurait donc introduit une abréviation pour <TT>seqp (:)</TT>,  par exemple - 
<PRE>
infixr 4 +&gt;
a +&gt; p = seqp (:) a b
</PRE>
pour pouvoir écrire ensuite 
<pre>
word = letter +&gt; word'
</pre> 
etc. Ainsi notre parseur n'est pas beaucoup plus long que la règle syntaxique, mais <EM>c'est un fragment de programme</EM> exécutable, qui returne un résultat intéressant. On peut naturellement abstraire la reconnaissance des lettres, pour pouvoir faire la même chose avec les nombres entiers, ou identificateurs alphanumériques :
<PRE>
many p = p +&gt; many' p
many' p = (p +&gt; many' p) # return []

ident = letter +&gt; many' alphanum
</PRE>
La même chose pour un parseur qui filtre un nombre quelconque d'espaces vides : <TT>many' (literal ' ')</TT>. Pour les nombres la situation peut être plus intriquée - nous pouvons demander au parseur de construire sur place la <SPAN class=ib>valeur numérique</SPAN> du nombre reconnu. Mais la solution qui marche pour les identificateurs sera mauvaise pour les nombres, à cause de l'associativité : rappelons-nous que l'algorithme de reconstruction qui a été implanté en TD ajoutait le <SPAN class=ib>dernier chiffre lu</SPAN> au fragment précédent multiplié par la base. Ceci suggère l'usage de la règle
<PRE class="he">
integ  ::= integ digit | digit
</PRE>
ce qui est récursive à gauche. Donc, il faut effectuer la normalisation de Greibach, et prévoir le passage du contexte au parseur suivant. Tout ceci peut être facilement réalisé. Voici la solution, écrite presque sans aucune activité cérébrale de haut niveau... D'abord, on ne veut plus les caractères, mais les nombres :
<PRE>
chiffre = digit &gt;&gt;= \c -&gt; return (ord c - ord '0')
</pre>
Le parseur <TT>chiffre</TT> possède le type <TT>UParser Char Int</TT>, il retourne un nombre entier. Ensuite on applique la règle de Greibach :
<PRE class=he>
integ ::= chiffre numlist 
numlist ::= EPS | chiffre numlist
</PRE>
et - <EM>n'oublions pas cette règle</EM> - le non-terminal "artificiel" <TT>numlist</TT> introduit par ma technique de Greibach, devient un parseur qui a besoin d'un paramètre supplémentaire - son contexte gauche.
<pre>
<span style="color:#0000A0">integ = chiffre &gt;&gt;= numlist</span>
numlist n = (chiffre &gt;&gt;= \m -&gt; numlist (10*n+m)) 
            # 
            return n
</PRE>
<p>

Regardez la première ligne en bleu. En TD nous l'avons écrite comme
<PRE>
integ = chiffre &gt;&gt;= \n -&gt; numlist n
</PRE>
mais le fabuleux protocole normal d'évaluation nous permet de simplifier la forme <TT>\x-&gt;f x</TT>, de la transformer en <TT>f</TT>.
<p>

ConstruisezSVP le parseur des nombres flottants, avec le point décimal, et le facteur exponentiel, p. ex. : 1.543E-12 . C'est un joli sujet d'examen.

<!-- ********************************************************* --><p>
<CENTER><IMG SRC="../icons/limarro.gif" WIDTH="576" HEIGHT="9" ALT="">
</CENTER>
<p>

<H3>Élimination des espaces</H3>

Le parseur qui reconnaît un espace est très simple : <TT>literal ' '</TT>. Un nombre quelconque d'espaces est cosommé par
<PRE>
blanks = many' (literal ' ')
</PRE>
et si on précède chaque objet (parseur) intéressant par <TT>blanks</TT>, on se débarasse de ce "fond" dans le programme parsée, par exemple
<PRE>
mot = blanks &gt;&gt;= \_ -&gt; word
</PRE>
<SPAN class=ib>Notez bien !</SPAN> Le parseur <TT>blanks</TT> consomme un certain nombre d'espaces, mais on ne fait absolument rien avec. Le résultat assemblé par <TT>many'</TT> n'a pas besoin d'être instancié - on ne le récupère jamais, donc on le passe à une fonction qui a besoin d'un paramètre pour des raisons formelles, mais il est anonyme. Une telle combinaison peut être si fréquente - par exemple la reconnaissance des séparateurs, des crochets ou des parenthèses qui ne sont jamais utilisées dans la construction du résultat final, que les auteurs de la couche monadique en Haskell ont introduit l'opérateur <TT>(&gt;&gt;)</TT>, <A href="#clamon">mentionné précédemment</A>. Quand même, l'usage du parseur <TT>blanks</TT> sera un peu inefficace, car les espaces sont d'abord assemblés dans une liste temporaire, pour ensuite être oubliés.
<p>

<SPAN class=ib>Exercice-conseil :</SPAN> je vous suggère de construire une variante du parseur <TT>many</TT> (et <TT>many'</TT>), qui lance séquentiellement son argument jusqu'à l'échec, mais qui d'emblée ne fait rien avec les résultats, et qui retourne une valeur "bidon" <TT>()</TT> (ne jamais confondre avec <TT>[]</TT>).

<H3>Construction de listes hétérogènes</H3>

Construisons un parseur capable de reconnaître et de traiter les listes style Prolog, éventuellement imbriquées, comme <TT>"[a,9,[[p],q],r,[],[p|s],r]"</TT>. Pour la simplicité, les "atomes" élementaires seront des lettres, et il n'y a pas d'espaces dans le texte, mais nous savons déjà comment étendre nos parseurs pour permettre un peu plus de souplesse.
<p>
Si le "car" d'une liste peut être également une liste, et si son "cdr" peut <B>ne pas l'être</B>, les listes Haskell sont inutilisables comme les structures internes retournées par le parseur. Nous devons construire des arborescences binaires complètes qui peuvent représenter la liste vide, un objet atomique, une liste régulière, et une paire type <TT>[x|y]</TT>, où <TT>x, y</TT> sont de nouveau des arbres quelconques. Bien sûr, l'équivalence connue en Prolog (et en Lisp) : <TT>[x|[y]] = [x,y]</TT>, etc. reste valide. Nous proposons donc la définition de l'objet (type) - résultat du parsing comme
<PRE>
data Arb = Nil | L Char | Nd Arb Arb
</PRE>
et la grammaire des listes:
<PRE class="he">
objet ::= lettre | liste
liste ::= [ lseq ]

lseq ::= EPS | objet lseq'
lseq' ::= EPS | , objet lseq' | "|" objet
</PRE>
La traduction de cela an parseurs ne doit pas poser aucun problème (et ce n'est pas le cas, dans votre intérêt est de le régler avant l'examen, c'est un conseil très sérieux). Voici cette traduction. Elle tient compte du fait que le résultat doit être un arbre de type <TT>Arb</TT>, même s'il s'agit d'un atome (feuille).
<PRE>
objet = letter &gt;&gt;= \c -&gt; return (L c) # liste
liste = literal '[' &gt;&gt; lseq &gt;&gt;= \l -&gt; literal ']' &gt;&gt; return l

lseq = seqp Nd objet lseq' # return Nil     -- Cool, non?
lseq' = literal ',' &gt;&gt; seqp Nd objet lseq' #
        literal '|' &gt;&gt; objet # return Nil
</PRE>
Toutes ces définitions sont très courtes, et elles continuent à être simples même dans des cas beaucoup plus complexes. Si vous trouvez ailleurs un formalisme permettant de définir les analyseurs syntaxiques de manière encore plus compacte (mais complète !), je vous rembourse la différence, et je vous accorde 15% de réduction sur votre prochain achat.

<!-- ********************************************************* --><p>
<CENTER><IMG SRC="../icons/limarro.gif" WIDTH="576" HEIGHT="9" ALT="">
</CENTER>
<p>

<H3>Discussion-intermezzo : les lexèmes classiques</H3>

Pour construire le compilateur d'un langage, il faut d'abord préciser ce langage, connaître sa grammaire. La base grammaticale du langage est son lexique, la définition des "mots". Pour un langage de programmation relativement classique la situation est simple, mais pas totalement triviale. Nous avons découvert ensemble que la réponse à la question : "qu'est-ce que c'est : <TT>99alpha</TT>" n'est pas évidente. (Votre réponse était : le silence accompagné de grimaces très sexy...) En fait, ceci peut être considéré comme un lexème illégal (p. ex. en Pascal), parfaitement légal (en Scheme), ou une suite de lexèmes : <TT>99</TT> et <TT>alpha</TT>. Ceci peut être rejeté (pour des raisons syntaxiques/sémantiques et non pas lexicales) par Hugs, ou être parfaitement légal en Metapost, qui est très malin, et introduira l'opérateur de multiplication entre 99 et alpha ...
<p>

Les lexèmes habituels sont :
<UL type="circle">
<LI> Les identificateurs. Les mots-clefs, qui peuvent être considérés comme des identificateurs résérvés, ou avoir une catégorisation <I>lexicale</I> spéciale.
<LI> Les nombres : entiers, flottants, entiers longs, entiers hexadécimaux, etc.
<LI> Les chaînes de caractères (le contenu des constantes <TT>" ... "</TT>, normalement stocké sans guillemets).
<LI> Les caractères : 'A'.
<LI> Toute sorte d'opérateurs : <TT>+, -, :, -*&gt;, /=, &lt;&lt</TT>, etc. Normalement le scanneur lexical doit chercher la suite la plus longue de caractères appartenant à la catégorie des opérateurs, et donc il est difficile de construire les objets qui contiennent les caractères spéciaux et les lettres ou chiffres. (Mais en Scheme/Lisp on peut faire n'importe quoi...)
<LI> Caractères de parenthésage généralisé : <TT>(, ), [, ], {, }</TT>. Dans quelques langages les combinaisons <TT>&gt;&gt;, &lt;&lt;</TT> ne sont pas des opérateurs, mais aussi des "parenthèses".
<LI> Les séparateurs : ",", ";", etc. Les espaces qui <I>peuvent</I> parfois être instanciés.
<li> Peut-être : les caractères comme l'apostrophe ou le guillemet.
<li> Le caractère d'échappement "\". Il faut faire attention. Par exemple en Haskell le <I>backslash</I> reste un caractère spécial, mais à l'intérieur des chaînes c'est le caractère d'échapement, et en dehors - c'est la forme "lambda", le constructeur des fonctions anonymes.
</UL>

La vie parfois est compliquée... Il est bien de savoir par exemple qu'en PostScript les chaînes de caractères sont des suites de caractères entre parenthèses, et non pas entre guillemets, et les parenthèses en FORTH délimitent les commentaires.

<p>
Nous allons construire encore <EM>en TD</EM> 
<UL>
<LI> un analyseur lexical universel qui reconnaît les chaînes, les opérateurs, qui élimine les blanks, etc., et 

<LI> un parseur d'expressions algébriques.
</UL>
Donc rien de nouveau, mais le résultat doit être relativement complet. Préparez-vous SVP !
<p>

<!-- ********************************************************* --><p>
<CENTER><IMG SRC="../icons/limarro.gif" WIDTH="576" HEIGHT="9" ALT="">
</CENTER>
<p>

<H3 style="color:#800080; border-width:3pt; border-color:#009000">Commentaire important !</H3>

Si on introduit des nouvelles structures de données composites, comme notre <TT>Arb</TT>, pour pouvoir faire quelque chose de raisonnable avec de telles données, il faut surcharger les opérations universelles sur les données, par exemple savoir afficher un tel objet (le transformer en chaîne de caractères), ou vérifier l'égalité entre deux objets. Ceci ne peut être <SPAN class=ib>complètement automatique</SPAN>. Il y a des objets qui ne doivent jamais être comparés, car soit ceci n'a pas de sens comme la comparaison de deux fonctions, ou peut déclencher une exception ou "planter" le système, p. ex. la comparaison de deux structures paresseuses "infinies". Si nous voulons pouvoir vérifier l'égalité entre deux valeurs de notre type composite, il le faut déclarer explicitement, en définissant par exemple l'instance
<PRE>
instance Eq Arb where
 Nil==Nil = True
 L x == L y  = x==y
 Nd a a' == Nd b b' = (a==a') && (b==b')
 _ == _ = False
</PRE>
On devrait ajouter une telle définition pour chaque type nouveau déclaré dans le programme, ce qui est assez pénible (mais souple). Si nous définissons un type algébrique standard : une alternative de quelques variantes, où chaque variante est un "record" identifié par une balise-constructeur, l'égalité "canonique" est évidente. Une variante ne peut être jamais égale à une autre ; pour le même constructeur il faut que les arguments soient égaux. Donc, en principe le compilateur peut ajouter une telle déclaration d'instance pour nous. Et dans la pratique aussi ! Il suffit d'ajouter après la déclaration du type une clause spéciale : <TT>deriving</TT>, par exemple
<PRE style="color:#0000B0">
data Arb = Nil | L Char | Nd Arb Arb 
  deriving (Eq,Show)
</PRE>

L'égalité est facile à "inventer". Avec l'affichage il y a un peu plus de problèmes, mais en principe le système peut essayer d'aficher les valeurs <SPAN class=ib>comme elles pourraient apparaître dans une constante de type souhaité</SPAN>, par exemple : "<TT>Nd (L 'a') (Nd (L 'b') Nil)"</TT>. Évidemment, il serait judicieux de prévoir les procédures d'affichage un peu plus raisonnables. En tout cas, quelques classes standard comme Eq, Show, mais également Ord (qui maintient les relations comme <TT>&gt;</TT>, <TT>&lt;=</TT>, etc. peuvent être instanciées pour notre nouveau type automatiquement.
<p>


<p>


<TABLE width=100%>
 <TR><TD align=left><A HREF="comres7.html"><IMG SRC="../icons/gb_larr.gif" border=0 align=absmiddle></A></TD>
<TD align=right><A HREF="comres9.html"><IMG SRC="../icons/gb_rarr.gif" border=0 align=absmiddle></A></TD>
</TR>
</TABLE>
<p>


</FONT>
</BODY>

</HTML>
